import * as t from '@babel/types';
import type { NodePath } from '@babel/traverse';
import TSProcessor from './TSProcessor';
import type { TSProcessorOptions } from './TSProcessor';
declare type ObjectProperties = t.ObjectExpression['properties'];
export declare type ProcessorConfig = {
    typescript?: boolean | TSProcessorOptions;
    evaluate?: boolean;
    CSSVariableFallback?: boolean;
    code: string;
    filename: string;
};
declare type CommonOptions = {
    postfix?: string;
};
declare type ObjectOptions = CommonOptions & {
    properties: ObjectProperties;
};
export declare class Processor {
    config: ProcessorConfig;
    tsProject?: TSProcessor;
    mixin: boolean;
    isStatic: boolean;
    classNameNodes: WeakSet<t.ObjectProperty>;
    optimizationPaths: Set<NodePath<any>>;
    variables: t.ObjectProperty[];
    private prepare;
    constructor({ config }: {
        config: ProcessorConfig;
    });
    isClassNameNode(node: any): boolean;
    classNamesToNode(classNames: object): t.ObjectProperty[];
    stylesToNode(key: string, value: unknown, { postfix }?: {
        postfix?: string | undefined;
    }): t.ObjectProperty[];
    processPropertyValue(key: string, path: NodePath<t.ObjectProperty>, { postfix, properties }: ObjectOptions): void;
    processObjectProperty(path: NodePath<t.ObjectProperty>, { postfix, properties }: ObjectOptions): void;
    processSpreadElement(path: NodePath<t.SpreadElement>, { postfix, properties }: ObjectOptions): void;
    processLogicalExpression(path: NodePath<t.LogicalExpression>, options: CommonOptions): void;
    processObjectExpression(path: NodePath<t.ObjectExpression>, { postfix }: CommonOptions): void;
    process(path: NodePath<any>, options?: CommonOptions): void;
    run(path: NodePath<t.ObjectExpression>, { mixin }?: {
        mixin?: boolean | undefined;
    }): {
        isStatic: boolean;
        optimizationPaths: Set<NodePath<any>>;
    } | null;
}
export {};
