import type { Node } from 'ts-morph';
import type { Project as TSProject, Symbol as TSSymbol, Type as TSType, ProjectOptions } from 'ts-morph';
export declare function getType(symbol?: TSSymbol): TSType;
export declare class DynamicType {
    value: any;
    type: TSType;
    constructor({ value, type }: {
        value: any;
        type: TSType;
    });
}
export declare class UnionType extends Array {
}
export declare const STATIC_KEY: unique symbol;
export declare function isStaticValue(value: any): any;
export declare function parseValue(type: TSType): ReturnType<typeof JSON.parse>;
export declare function parseObject(type?: TSType): {
    [key: string]: Set<ReturnType<typeof parseValue>>;
};
export declare type TSProcessorOptions = ProjectOptions;
export default class TSProcessor {
    project: TSProject;
    constructor(config: TSProcessorOptions);
    getTypeAtPos(filename: string, code: string, start: number, end: number): Node | void;
}
