import * as t from '@babel/types';
import type { NodePath, PluginPass } from '@babel/core';
import type { ProcessorConfig } from './Processor';
declare type FilenameGetter = (code?: string) => string;
declare type FilepathGetter = (filename: string) => string;
export declare type Env = 'development' | 'production' | 'test';
declare type ExtractCSSType = boolean | 'production' | 'development';
export declare type OutputOptions = {
    getCSSFilename: FilenameGetter;
    getCSSFilepath: FilepathGetter;
    getJSFilename: FilenameGetter;
    getJSFilepath: FilepathGetter;
    relativeEntryPath: boolean;
    extractCSS: ExtractCSSType;
};
export declare function output({ env, state, config: { getCSSFilename, getCSSFilepath, getJSFilename, getJSFilepath, relativeEntryPath, extractCSS, }, }: {
    env: Env;
    state: PluginPass;
    config?: Partial<OutputOptions>;
}): void;
export declare const createProcessors: (config: ProcessorConfig) => {
    handlers: {
        css: (path: NodePath<t.MemberExpression | t.CallExpression>, { mixin }?: {
            mixin?: boolean | undefined;
        }) => void;
        mixin: (path: any) => void;
    };
    finish(): {
        isStatic: boolean;
    };
};
export {};
