import type { NodePath, PluginPass, ConfigAPI } from '@babel/core';
import type { OutputOptions } from './handlers';
import type { ProcessorConfig } from './Processor';
declare type CompileOptions = {
    /**
     * Use typescript language server
     *
     * By default, true for typescript files
     * @default true
     */
    typescript: ProcessorConfig['typescript'];
    /**
     * Apply static evaluation optimizations
     *
     * @default true
     */
    evaluate: ProcessorConfig['evaluate'];
    /**
     * Use CSS Variables fallback
     * If true, then even not optimized dynamic values would be optimized as possible
     *
     * @default true
     */
    unstable_CSSVariableFallback: ProcessorConfig['CSSVariableFallback'];
};
export declare type MacroConfig = Partial<{
    compileOptions: Partial<CompileOptions>;
    outputOptions: Partial<OutputOptions>;
}>;
export declare type MacroOptions = {
    state: PluginPass;
    babel: ConfigAPI;
    config?: MacroConfig;
    references: Record<string, NodePath[]>;
};
export declare function macro({ references, state, config: _config }: MacroOptions): {
    keepImports: boolean;
} | undefined;
export {};
