"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var findCacheDir=_interopDefault(require("find-cache-dir")),path=_interopDefault(require("path")),mkdirp=_interopDefault(require("mkdirp")),t=require("@babel/types"),core=require("@babel/core"),register=require("@babel/register"),register__default=_interopDefault(register),evaluatePath=_interopDefault(require("babel-helper-evaluate-path")),resolve=_interopDefault(require("resolve")),taddy=require("taddy"),core$1=require("@taddy/core"),helperModuleImports=require("@babel/helper-module-imports"),fs=_interopDefault(require("fs")),stringHash=_interopDefault(require("string-hash"));function _extends(){return(_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e}).apply(this,arguments)}function getType(e){return null==e?void 0:e.getTypeAtLocation(e.getDeclarations()[0])}class DynamicType{constructor({value:e,type:t}){this.value=e,this.type=t}}class UnionType extends Array{}function isRecord(e){var t;return"Record"===(null==e||null===(t=e.getAliasSymbol())||void 0===t?void 0:t.getEscapedName())}const STATIC_KEY=Symbol("__TADDY_STATIC_KEY__");function isStaticValue(e){return!e||"object"!=typeof e||!(e instanceof UnionType)&&(e[STATIC_KEY]||!1)}function filterValue(e){return String(e).startsWith("-")}function parseValue(e){var t;if(!e)return null;if(e.isAny()||e.isUnknown())return new DynamicType({value:null,type:e});if(isRecord(e))return parseRecord(e);if(e.isArray())return parseArray(e);if(e.isUnion())return new UnionType(...e.getUnionTypes().map(parseValue));if(e.isObject())return parseObject(e);let r=null==e?void 0:e.getText();if(!r||(null===(t=r)||void 0===t?void 0:t.includes("&")))return null;try{r=JSON.parse(r)}catch(t){return new DynamicType({value:r,type:e})}return filterValue(r)?null:r}function parseMixinParameters(e){return parseValue(getType(e))}function parseMixin(e){const t=getType(e);return 0===(null==t?void 0:t.getCallSignatures().length)?parseMixinParameters(e):null==t?void 0:t.getCallSignatures()[0].getParameters().map(parseMixinParameters)}function parseRecord(e){const[t,r]=e.getAliasTypeArguments(),n=parseValue(t),i=parseValue(r);return Array.isArray(n)?n.map(e=>({[e]:i,[STATIC_KEY]:i[STATIC_KEY]})):{[n]:i,[STATIC_KEY]:i[STATIC_KEY]}}function parseArray(e){const t=[];function r(e){const r=parseValue(e);if(!r)return;const n=isStaticValue(r);t[STATIC_KEY]=t[STATIC_KEY]&&n,t.push(n?r:new Set([].concat(r).filter(Boolean)))}t[STATIC_KEY]=!0;const n=e.getArrayElementTypeOrThrow();for(let e of n.getUnionTypes()||[n])r(e);return t}function parseObject(e){const t={};let r=!0;for(const i of null!==(n=null==e?void 0:e.getProperties())&&void 0!==n?n:[]){var n;const e=i.getEscapedName(),s=parseMixin(i);if(!s)continue;const o=isStaticValue(s);r=r&&o,t[e]=o?s:new Set([].concat(s).filter(Boolean))}return t[STATIC_KEY]=r,t}class TSProcessor{constructor(e){const{Project:t}=require("ts-morph");this.project=new t(_extends({tsConfigFilePath:path.join(process.cwd(),"tsconfig.json")},e))}getTypeAtPos(e,t,r,n){let i=this.project.getSourceFile(e);return i&&i.getFullText()!==t?i.replaceText([0,i.getEnd()],t):i=this.project.createSourceFile(e,t,{overwrite:!0}),i.getDescendantAtStartWithWidth(r,n-r)}}const MACRO_NAME="taddy.macro",PACKAGE_NAME="taddy",cacheDir=findCacheDir({name:PACKAGE_NAME})||path.join(require.resolve("taddy"),".cache"),getCachedModuleFilepath=e=>`.cache/${PACKAGE_NAME}/${e}`;try{mkdirp.sync(cacheDir)}catch(e){console.error("TADDY","can not create cache dir",e)}const cache=new WeakMap;class BindingError extends Error{}function findBindings(e){function t(t,r,i){r.parentPath.isMemberExpression()&&(r=r.parentPath.get("object"));const{parentPath:s,node:o}=r;if(!(s.isExpression()||s.isSpreadElement()||s.isObjectProperty()&&(s.node.value===o||s.node.computed)))return;if(!("name"in o)||"string"!=typeof o.name)return;const{name:a}=o,c=e.scope.getBinding(a),l=t.scope.getBinding(a);if(!l)return;if(c!==l)return;if(l.constantViolations.length>0)throw new BindingError("CONSTANT VIOLATION");const{path:p}=l;if(!i.has(l)){if(p.parentPath.isFunctionExpression()&&"params"===p.listKey)throw new BindingError("FUNCTION ARGUMENT");i.add(l),p.isImportSpecifier()||(n(p)||[]).forEach(e=>i.add(e))}}const r=new Set;function n(e){if(e.isObjectPattern())throw new BindingError("OBJECT PATTERN");if(cache.has(e))return cache.get(e);if(r.has(e))throw new BindingError("INFINITE LOOP");r.add(e);const n=new Set;return e.isIdentifier()&&t(e,e,n),e.traverse({Identifier(r){t(e,r,n)}}),cache.set(e,n),n}return n(e)}function getPathsByBindings(e){const t=new Set;for(let r of e)r.path.isImportSpecifier()||r.path.isVariableDeclarator()?t.add(r.path.parentPath):t.add(r.path);return t}function buildCodeByPath(e){return Array.from(getPathsByBindings(findBindings(e))).sort((e,t)=>e.node.start-t.node.start).map(e=>e.toString()).join("\n")}const DEFAULT_PRESETS=["@babel/preset-typescript","@babel/preset-react",["@babel/preset-env",{targets:{node:"current"}}]],EXTENSIONS=[".es6",".es",".tsx",".ts",".jsx",".js",".mjs"],macroRe=new RegExp(MACRO_NAME.replace(".","\\."),"g"),EVAL_FILENAME_POSTFIX="@__TADDY_EVALUATE__";function isTaddyEvaluation(e){return e.filename.includes(EVAL_FILENAME_POSTFIX)}function evaluate(e){const t=evaluatePath(e);if(t.confident)return{value:t.value};try{const t="__taddy__",r=buildCodeByPath(e).replace(macroRe,PACKAGE_NAME).concat(`${t}(${e.toString()})`),{opts:n}=e.hub.file,i=path.extname(n.filename),s=path.basename(n.filename,i),o=path.dirname(n.filename),a={babelrc:!1,configFile:!1,filename:path.join(o,s+EVAL_FILENAME_POSTFIX+i),plugins:[],presets:[...DEFAULT_PRESETS]},{code:c}=core.transformSync(r,a)||{};if(!c)return{};const l=new Function("require",t,c);let p;return register__default(_extends({},a,{extensions:EXTENSIONS})),l(e=>e===PACKAGE_NAME?taddy:require(resolve.sync(e,{extensions:EXTENSIONS,basedir:path.dirname(n.filename)})),e=>{p=e}),register.revert(),{value:p}}catch(e){return{error:e}}}function getObjectPropertyKey(e){return t.isIdentifier(e.node.key)?e.node.key.name:t.isLiteral(e.node.key)&&"value"in e.node.key?e.node.key.value:null}function mergeObjectProperties(e){const r=new Map;function n(e,t){r.delete(e),r.set(e,t)}for(const r of e){if(!t.isObjectProperty(r)){n(r,r);continue}const{key:e}=r;t.isIdentifier(e)?n(e.name,r):t.isStringLiteral(e)?n(e.value,r):n(r,r)}return Array.from(r.values())}function isTaddy(e){const{path:t}=e,{parentPath:r}=t;return r.isImportDeclaration()&&"taddy"===r.node.source.value}function optimizeBindings(e){let t;try{t=findBindings(e)}catch(e){return void console.log("ERROR",{error:e})}for(let e of t)if(!isTaddy(e)&&(e.references--,optimizeBindings(e.path),0===e.references)){e.path.remove();const{parentPath:t}=e.path;if(t.isImportDeclaration()&&0===t.node.specifiers.length){t.remove();continue}}}function optimizeStaticStyles(e){const r=[],n=[],i=[];for(const s of e.get("properties")){if(!s.isObjectProperty())throw new Error("Cant optimize this path");const e=String(getObjectPropertyKey(s)),o=s.get("value");"className"!==e?"style"!==e&&e!==core$1.VARS_KEY?o.isStringLiteral()?r.push(e+o.node.value):o.isBooleanLiteral()?r.push(e):n.push(t.binaryExpression("+",t.stringLiteral(e),o.node)):i.push(s.node):n.push(o.node)}let s=t.stringLiteral(r.join(" "));if(0!==n.length){s.value+=s.value?" ":"";const e=s,r=1===n.length?n[0]:t.templateLiteral([t.templateElement({raw:""})].concat([...Array(n.length-1)].fill(t.templateElement({raw:" "}))).concat(t.templateElement({raw:""})),n);s=t.binaryExpression("+",e,r)}0!==i.length?e.node.properties=i.concat(t.objectProperty(t.identifier("className"),s)):e.replaceWith(s)}function getLiteralValue(path){return eval(path.toString())}function getHashedName(e,{postfix:t}){return core$1.config.nameGenerator.getName(e,"",{postfix:t}).join("")}class Processor{constructor({config:e}){this.config=e,e.typescript&&(this.tsProject=new TSProcessor(!0===e.typescript?{}:e.typescript))}prepare({mixin:e}){this.mixin=e,this.isStatic=!1,this.variables=[],this.classNameNodes=new WeakSet,this.optimizationPaths=new Set}isClassNameNode(e){return this.classNameNodes.has(e)}classNamesToNode(e){const r=[];for(const n in e){const i=e[n],s=t.identifier(n),o="boolean"==typeof e[n]?t.booleanLiteral(i):t.stringLiteral(String(i)),a=t.objectProperty(s,o);this.classNameNodes.add(a),r.push(a)}return r}stylesToNode(e,t,{postfix:r=""}={}){const{className:n}=taddy.$css({[e]:t},{postfix:r});return this.classNamesToNode(n)}processPropertyValue(e,r,{postfix:n,properties:i}){const s=r.get("key"),o=r.get("value"),a=Symbol("STOP"),c=e=>{var t;const r=null===(t=this.tsProject)||void 0===t?void 0:t.getTypeAtPos(this.config.filename,this.config.code,e.node.start||0,e.node.end||0);if(r)return parseValue(r.getType())};(()=>{if(!o.isLiteral())return!1;const t=getLiteralValue(o);return i.push(...this.stylesToNode(e,t,{postfix:n})),!0})()||(()=>{if(!o.isObjectExpression())return!1;this.process(o,{postfix:n+e});let r=[];for(const e of o.node.properties)this.isClassNameNode(e)?(r.length&&(i.push(t.objectProperty(s.node,t.objectExpression(r))),r=[]),i.push(e)):r.push(e);return r.length&&i.push(t.objectProperty(s.node,t.objectExpression(r))),!0})()||(()=>{if(!this.config.evaluate)return!1;const{value:t}=evaluate(o);return!!t&&(i.push(...this.stylesToNode(e,t,{postfix:n})),this.optimizationPaths.add(r),!0)})()||(()=>{if(!this.config.typescript)return!1;let s;if(s="composes"===e&&o.isArrayExpression()?(e=>{const t=[];t[STATIC_KEY]=!0;for(let r of e.get("elements")){if(!r)return;const e=c(r);if(e===a)return;t[STATIC_KEY]=t[STATIC_KEY]&&isStaticValue(e),t.push(e)}return t})(o):c(o),!s)return!1;if(isStaticValue(s))return i.push(...this.stylesToNode(e,s,{postfix:n})),this.optimizationPaths.add(r),!0;if("composes"===e)return!1;const l=[].concat(s);let p=!0;if(l.forEach(t=>{t instanceof DynamicType?p=!1:taddy.$css({[e]:t},{postfix:n})}),!p)return!1;const u=getHashedName(e,{postfix:n});return i.push(t.objectProperty(t.identifier(u),t.callExpression(t.identifier("css.h"),[o.node]))),!0})()||(()=>{if(!this.config.CSSVariableFallback)return!1;if(this.mixin&&""!==n||"composes"===e||":"===e[0]||/[\W]/.test(e))return!1;const r="--"+getHashedName(e,{postfix:n});return this.variables.push(t.objectProperty(t.stringLiteral(r),o.node)),i.push(...this.stylesToNode(e,`var(${r})`,{postfix:n})),!0})()||i.push(r.node)}processObjectProperty(e,{postfix:t="",properties:r}){const n=String(getObjectPropertyKey(e));"className"!==n&&"style"!==n&&null!==n?this.processPropertyValue(n,e,{postfix:t,properties:r}):r.push(e.node)}processSpreadElement(e,{postfix:t="",properties:r}){(()=>{if(!this.config.evaluate)return!1;const{value:n}=evaluate(e.get("argument"));if(!n)return!1;const{className:i}=taddy.$css(n,{postfix:t});return r.push(...this.classNamesToNode(i)),this.optimizationPaths.add(e),!0})()||(()=>{var n;if(!this.config.typescript)return!1;const{argument:i}=e.node,s=null===(n=this.tsProject)||void 0===n?void 0:n.getTypeAtPos(this.config.filename,this.config.code,i.start||0,i.end||0);if(!s)return!1;const o=parseValue(s.getType());if(!isStaticValue(o))return!1;const{className:a}=taddy.$css(o,{postfix:t});return r.push(...this.classNamesToNode(a)),this.optimizationPaths.add(e),!0})()||(this.process(e.get("argument")),r.push(e.node))}processLogicalExpression(e,t){this.process(e.get("left"),t),this.process(e.get("right"),t)}processObjectExpression(e,{postfix:t=""}){const r=[];for(const n of e.get("properties"))n.isObjectProperty()?this.processObjectProperty(n,{postfix:t,properties:r}):n.isSpreadElement()?this.processSpreadElement(n,{postfix:t,properties:r}):r.push(n.node);e.node.properties=mergeObjectProperties(r)}process(e,t={}){e.isLogicalExpression()?this.processLogicalExpression(e,t):e.isObjectExpression()&&this.processObjectExpression(e,t)}run(e,{mixin:r=!1}={}){if(!e.isObjectExpression())return null;this.prepare({mixin:r}),this.process(e),this.variables.length>0&&e.node.properties.push(t.objectProperty(t.identifier(core$1.VARS_KEY),t.objectExpression(this.variables)));const n=!this.mixin&&e.node.properties.every(e=>!(!t.isObjectProperty(e)||"name"in e.key&&"composes"===e.key.name));return n&&optimizeStaticStyles(e),{isStatic:n,optimizationPaths:this.optimizationPaths}}}let LAST_INDEX=0,STYLES=[];function getStylesState(){const{rules:e}=taddy.ruleInjector.styleSheet,t=e.slice(LAST_INDEX);LAST_INDEX=e.length;const r=[...t].map(e=>e.cssText||"");return STYLES.push(...r),{added:r,total:STYLES}}function getRelativeFilepath(e,t){return"./"+path.relative(path.dirname(e),t)}function writeDevEntry({styles:e,jsFilepath:t}){fs.writeFile(t,`\nvar getStyleNodeById = require('taddy').getStyleNodeById\nvar STYLES = '${e}'\nvar state = {current: STYLES}\nvar isBrowser = typeof window !== 'undefined'\nif (isBrowser && !getStyleNodeById('taddy').innerHTML) {\n    state.current = window.__TADDY_STYLES__ = window.__TADDY_STYLES__ || STYLES\n    getStyleNodeById('taddy').innerHTML = state.current\n}\nmodule.exports.STYLES = STYLES;\nmodule.exports.state = state;\nmodule.exports.taddy_invalidate = function (newStyles) {\n    if (!newStyles) return\n    state.current += newStyles\n    if (isBrowser) getStyleNodeById('taddy').innerHTML += newStyles\n}\n`,e=>{e&&console.error("TADDY WRITEFILE ERROR",e)})}function writeProdEntry({styles:e,jsFilepath:t,cssFilepath:r,extractCSS:n}){let i;i=n?`require('${getRelativeFilepath(t,r)}');`:`\nvar getStyleNodeById = require('taddy').getStyleNodeById\nvar STYLES = '${e}'\nif (typeof window !== 'undefined') {\n    getStyleNodeById('taddy').innerHTML = STYLES\n}\nmodule.exports.STYLES = STYLES\n`,contentMap.has(i)||(contentMap.set(i,!0),fs.writeFile(t,i,e=>{e&&console.error("TADDY WRITEFILE ERROR",e)}))}function getMtime(e){return Number(fs.statSync(e).mtime)}const filesMap=new Map,contentMap=new Map;function readFileSync(e){let t="";try{const r=getMtime(e);if(filesMap.has(r))return filesMap.get(r);t=fs.readFileSync(e).toString(),filesMap.set(r,t),contentMap.set(t,r)}catch(e){}return t}function writeCSSFileSync(e,t,r){contentMap.has(t+r)||fs.appendFileSync(e,r)}function output({env:e,state:r,config:{getCSSFilename:n=(()=>"atoms.css"),getCSSFilepath:i=(e=>path.join(cacheDir,e)),getJSFilename:s=(e=>"entry"+(e?"."+e:"")+".js"),getJSFilepath:o=(e=>path.join(cacheDir,e)),relativeEntryPath:a=!1,extractCSS:c=!1}={}}){const{added:l}=getStylesState(),p=i(n()),u=readFileSync(p),d=l.filter(e=>!u.includes(e)).join("");let f=u+d;writeCSSFileSync(p,u,d);const h=r.file.path,{filename:m}=r;function y(e){return a?getRelativeFilepath(m,e):getCachedModuleFilepath(path.basename(e))}if("development"===e){const e=String(stringHash(f)),r=o(s(e));writeDevEntry({jsFilepath:r,cssFilepath:p,extractCSS:c,styles:f});const n=y(r),i=helperModuleImports.addNamed(h,"taddy_invalidate",n);return void h.pushContainer("body",t.callExpression(i,[t.stringLiteral(d),t.stringLiteral(e)]))}const g=o(s());writeProdEntry({jsFilepath:g,cssFilepath:p,extractCSS:c,styles:f});const S=y(g);helperModuleImports.addSideEffect(h,S)}function isPathRemoved(e){do{if(e.removed)return!0}while(e=e.parentPath);return!1}const createProcessors=e=>{const t=[],r=[],n=new Processor({config:e}),i={css:(e,{mixin:i=!1}={})=>{if(e.isMemberExpression()&&"name"in e.node.property&&"mixin"===e.node.property.name)return void t.push(e.parentPath);if(!e.isCallExpression())return;const s=e.get("arguments")[0],o=n.run(s,{mixin:i});if(!o)return;const{isStatic:a,optimizationPaths:c}=o;r.push({isStatic:a,optimizationPaths:c}),e.node.arguments=[s.node]},mixin:e=>i.css(e,{mixin:!0})};return{handlers:i,finish(){let e=!0;for(let t of r){e=e&&t.isStatic;for(let e of t.optimizationPaths)optimizeBindings(e)}for(let e of t)isPathRemoved(e)||i.css(e,{mixin:!0});return{isStatic:e}}}};function mapCompileOptions({filename:e,code:t,evaluate:r=!0,typescript:n=/\.tsx?$/.test(e),unstable_CSSVariableFallback:i=!0}){return{filename:e,code:t,evaluate:r,typescript:n,CSSVariableFallback:i}}function macro({references:e,state:r,config:n={}}){const i=_extends({env:"production"},n);if(isTaddyEvaluation(r))return;const s=r.file.path,o=r.file.code,{filename:a}=r,{handlers:c,finish:l}=createProcessors(mapCompileOptions(_extends({},i.compileOptions,{filename:a,code:o})));for(const t in e)c[t]&&e[t].forEach(e=>c[t](e.parentPath));let p;s.traverse({ImportDeclaration(e){const{node:r}=e;r.source.value!==PACKAGE_NAME&&r.source.value!==MACRO_NAME||(p=e,p.node.source=t.stringLiteral("taddy"),e.stop())}});const{isStatic:u}=l();return u&&p&&(p.node.source=t.stringLiteral("@taddy/core")),output({env:i.env,state:r,config:i.outputOptions}),{keepImports:!0}}function getImportNames(e){const t=e.node.local.name;return e.isImportSpecifier()?{localName:t,importedName:e.node.imported.name}:e.isImportDefaultSpecifier()?{localName:t,importedName:"default"}:{localName:t,importedName:"namespace"}}function findReferences(e){const t={};for(let r of e){const{localName:e,importedName:n}=getImportNames(r),i=r.scope.getBinding(e);(null==i?void 0:i.referencePaths)&&(t[n]=i.referencePaths)}return t}function plugin(e,t){return{name:"taddy",pre(){this.references={}},visitor:{ImportDeclaration(r,n){isTaddyEvaluation(n)||r.node.source.value===PACKAGE_NAME&&(Object.assign(this.references,findReferences(r.get("specifiers"))),0!==Object.keys(this.references).length&&macro({references:this.references,babel:e,state:n,config:t}))}}}}exports.default=plugin,exports.macro=macro;
//# sourceMappingURL=babel-plugin.cjs.production.min.js.map
